/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::multibuttonentry::item_prepend(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::multibuttonentry::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_clear());
}

inline void elm::multibuttonentry::item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
}

inline ::elm::widget_item elm::multibuttonentry::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::multibuttonentry::item_append(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_append(::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::multibuttonentry::item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
}

inline void elm::multibuttonentry::item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
}

inline ::elm::widget_item elm::multibuttonentry::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::multibuttonentry::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::multibuttonentry::editable_set(bool editable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_editable_set(::efl::eolian::to_c(editable_)));
}

inline bool elm::multibuttonentry::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::multibuttonentry::expanded_set(bool expanded_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_expanded_set(::efl::eolian::to_c(expanded_)));
}

inline void elm::multibuttonentry::format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::multibuttonentry::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::multibuttonentry::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::multibuttonentry::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::multibuttonentry::entry_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::multibuttonentry::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::item_prepend(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::multibuttonentry::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_clear());
}

inline void eo_cxx::elm::multibuttonentry::item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::item_append(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_append(::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::multibuttonentry::item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
}

inline void eo_cxx::elm::multibuttonentry::item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::multibuttonentry::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::multibuttonentry::editable_set(bool editable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_editable_set(::efl::eolian::to_c(editable_)));
}

inline bool eo_cxx::elm::multibuttonentry::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::multibuttonentry::expanded_set(bool expanded_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_expanded_set(::efl::eolian::to_c(expanded_)));
}

inline void eo_cxx::elm::multibuttonentry::format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::multibuttonentry::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::multibuttonentry::entry_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::multibuttonentry::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::multibuttonentry::operator ::elm::multibuttonentry() const
{
   return *static_cast<::elm::multibuttonentry const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::multibuttonentry::operator ::elm::multibuttonentry&()
{
   return *static_cast<::elm::multibuttonentry*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::multibuttonentry::operator ::elm::multibuttonentry const&() const
{
   return *static_cast<::elm::multibuttonentry const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_multibuttonentry_item_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_prepend(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_multibuttonentry_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_multibuttonentry_item_filter_remove_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->item_filter_remove(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_item_insert_before_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * before_, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_before(::efl::eolian::to_cxx<::elm::widget_item>(before_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_multibuttonentry_item_filter_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->item_filter_prepend(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_multibuttonentry_item_filter_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->item_filter_append(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_item_insert_after_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * after_, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_after(::efl::eolian::to_cxx<::elm::widget_item>(after_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(label_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_multibuttonentry_editable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->editable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_multibuttonentry_editable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool editable_)
{
   try
      {
         static_cast<T*>(self->this_)->editable_set(::efl::eolian::to_cxx<bool>(editable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_multibuttonentry_expanded_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->expanded_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_multibuttonentry_expanded_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool expanded_)
{
   try
      {
         static_cast<T*>(self->this_)->expanded_set(::efl::eolian::to_cxx<bool>(expanded_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_multibuttonentry_format_function_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Format_Cb format_function_, const void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->format_function_set(format_function_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_multibuttonentry_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_first_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_last_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->last_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_multibuttonentry_entry_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->entry_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_multibuttonentry_selected_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::multibuttonentry >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual ::elm::widget_item item_prepend(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(::efl::eolian::to_c(label_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_clear());
      }

      virtual void item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
      }

      virtual ::elm::widget_item item_insert_before(::elm::widget_item before_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(label_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_append(::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_append(::efl::eolian::to_c(label_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
      }

      virtual void item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
      }

      virtual ::elm::widget_item item_insert_after(::elm::widget_item after_, ::efl::eina::string_view label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(label_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void editable_set(bool editable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_editable_set(::efl::eolian::to_c(editable_)));
      }

      virtual bool expanded_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void expanded_set(bool expanded_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_expanded_set(::efl::eolian::to_c(expanded_)));
      }

      virtual void format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item first_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item last_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object entry_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item selected_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::multibuttonentry >
{
   static constexpr int value = 
#if defined(MULTIBUTTONENTRY_PROTECTED) && defined(MULTIBUTTONENTRY_BETA)
      18
#elif defined(MULTIBUTTONENTRY_PROTECTED)
      18
#elif defined(MULTIBUTTONENTRY_BETA)
      18
#else
      18
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::multibuttonentry>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_filter_remove_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_remove);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_insert_before_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_insert_before);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_filter_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_filter_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_item_insert_after_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_insert_after);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_editable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_editable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_editable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_editable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_expanded_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_expanded_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_expanded_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_expanded_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_format_function_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_format_function_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_first_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_first_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_last_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_last_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_entry_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_entry_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_multibuttonentry_selected_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_selected_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::multibuttonentry >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::multibuttonentry>)
{
   return (ELM_MULTIBUTTONENTRY_CLASS);
}

} } }

/// @endcond

